/**************************************************************************
	Program Name : HtmlHelper.java
	Description  : Html을 편하게 만드는 함수
	Refer	:	
 **************************************************************************/

package wizframe.jfw.core;

import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;

import util.NumUt;


public class Calen {

	final static SimpleDateFormat fmt1 = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");

	Calendar cal = null;
	
    public static Calen getInstance() {
    	Calen cad = new Calen();
    	return cad;
    }

    public Calen() {
    	cal = Calendar.getInstance();
    }
    
	@Override
	public String toString() {
		String txt = fmt1.format(cal.getTime());
		return txt;
	}

	final static SimpleDateFormat fmt2 = new SimpleDateFormat("yyyy-MM-dd E HH:mm:ss");
	public String toYMDAHMS() {
		String txt = fmt2.format(cal.getTime());
		return txt;
	}

	public void set(int y, int m, int d, int h, int mi, int s) {
		cal.set(y,m,d, h,mi,s);		
	}

	public int get(int field) {
		return cal.get(field);
	}

	public void add(int field, int amount) {
		cal.add(field, amount);		
	}

	public Date getTime() {
		return cal.getTime();
	}

	public long getMili() {
		return cal.getTimeInMillis();
	}

	public void setTime(long mili) {
		cal.setTimeInMillis(mili);
	}

	public void set(int field, int value) {
		cal.set(field, value);		
	}


	public static String toYMDHM(String dt14) {
		try {
			String d = dt14;
			return String.format("%s-%s-%s %s:%s",
				d.substring(2,4), d.substring(4,6), d.substring(6,8),
				d.substring(8,10), d.substring(10,12) );
		} catch (Exception e) {
			return dt14;
		}
	}
	
	public static String toYMDHMS(String dt14) {
		try {
			String d = dt14;
			return String.format("%s-%s-%s %s:%s:%s",
				d.substring(0,4), d.substring(4,6), d.substring(6,8),
				d.substring(8,10), d.substring(10,12) , d.substring(12,14) );
		} catch (Exception e) {
			return dt14;
		}
	}
	
	public static String toMDHM(String dt14) {
		try {
			String d = dt14;
			return String.format("%s-%s %s:%s",
				d.substring(4,6), d.substring(6,8),
				d.substring(8,10), d.substring(10,12) );
		} catch (Exception e) {
			return dt14;
		}
	}

	public static String toDHMS(String dt14) {
		try {
			String d = dt14;
			return String.format("%s %s:%s:%s",
				d.substring(6,8),
				d.substring(8,10), d.substring(10,12), d.substring(12,14) );
		} catch (Exception e) {
			return dt14;
		}
	}

	final static SimpleDateFormat fmt3 = new SimpleDateFormat("yyyyMMddHHmmss");

	public static String curYMDHMS14() {
		return fmt3.format(new Date());
	}
	
	public static String curYMDHMS19() {
		return fmt1.format(new Date());
	}

	public static String secToHMS(String secs) {
		return secToHMS(Integer.parseInt(secs));
	}
	
//	public static String secToHMS(int ss) {
//		try {
//			int mm = ss/60; ss %= 60;
//			int hh = mm/60; mm %= 60;
//
//			if (hh==0)
//				return String.format("%d:%02d", mm, ss);
//			else
//				return String.format("%d:%02d:%02d", hh, mm, ss);
//		} catch (Exception e) {
//			return ss+"";
//		}
//	}

	public static String secToColonHMS(int se) {
		int mi = se/60; se %= 60;
		int ho = mi/60; mi %= 60;
		int da = ho/24; ho %= 24;

		if 		(da>0)	return String.format("%dd %02d:%02d:%02d", da, ho, mi, se);
		else  return String.format("%2d:%02d:%02d", ho, mi, se);
		//else if (mi>0)	return String.format("%2d:%02d", mi, se);
		//else			return String.format("%2d", se);
	}

	public static String secToHMS(int se) {
		int mi = se/60; se %= 60;
		int ho = mi/60; mi %= 60;
		int da = ho/24; ho %= 24;

		if 		(da>0)	return String.format("%dd %02dh %02dm %02ds", da, ho, mi, se);
		else if (ho>0)	return String.format("%2dh %02dm %02ds", ho, mi, se);
		else if (mi>0)	return String.format("%2dm %02ds", mi, se);
		else			return String.format("%2ds", se);
	}

	public static String secToHM(int se) {
		int mi = se/60; se %= 60;
		int ho = mi/60; mi %= 60;
		int da = ho/24; ho %= 24;

		if 		(da>0)	return String.format("%dd %02dh", da, ho);
		else if (ho>0)	return String.format("%2dh %02dm", ho, mi);
		else if (mi>0)	return String.format("%2dm %02ds", mi, se);
		else			return String.format("%2ds", se);
	}

	public static int toSec(String hms) {
		String []ar = hms.split(":");
		if (ar.length<3) return 0;
		
		int sec = NumUt.toInt(ar[0], 0) *3600 +NumUt.toInt(ar[1], 0) *60 +  NumUt.toInt(ar[2], 0);  
		return sec;
	}
	
	/**
	 * parse yyyy-MM-dd HH:mm:ss as long
	 * @return
	 */
	public static long parse(String ymdhms) {
		try {
			SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
			Date date = format.parse(ymdhms);
			return date.getTime();
		} catch (Exception e) {
			return 0;
		}
	}

}

