

package wizframe.jfw.core;

public class Caller {


	/**
	 * 
	 * @param thisName
	 * @return
	 */
	public String callerClassName(int skipLevel) {
		StackTraceElement tr = getCaller(skipLevel);
		
		if (tr==null) return "nul";
		String name = tr.getClassName();
		return name;
	}

	/**
	 * 
	 * @param thisName
	 * @return
	 */
	public String callerFileName(int skipLevel) {
		StackTraceElement tr = getCaller(skipLevel);
		
		if (tr==null) return "nul";
		String name = tr.getClassName();
		name = name.substring(name.lastIndexOf('.')+1);
		return name;
	}

	/**
	 * 
	 * @param thisName
	 * @return
	 */
	public String callerMethod(int skipLevel) {
		StackTraceElement tr = getCaller(skipLevel);
		
		if (tr==null) return "nul";
		String name = tr.getClassName();
		name = name.substring(name.lastIndexOf('.')+1);
		return name + "." + tr.getMethodName() + "(" + tr.getLineNumber()+")";
	}
	
	private StackTraceElement getCaller(int skipLevel) {
		StackTraceElement[] trace = new Exception("").getStackTrace();
		
		int i=0;
		// skip this class
		String name = trace[i].getClassName();
		for(i++; i<trace.length; i++) {
			if (!name.equals(trace[i].getClassName()) )
				break;
		}
	
		// skip caller 1
		for (int j=0; j<skipLevel; j++) {
			name = trace[i].getClassName();
			for(i++; i<trace.length; i++) {
				if (!name.equals(trace[i].getClassName()) )
					break;
			}
		}
	
		if (i<trace.length)
			return trace[i];
		return null;
	}

}

