

package wizframe.jfw.core;

import java.net.InetAddress;
import java.net.NetworkInterface;
import java.net.SocketException;
import java.util.Enumeration;

import wizframe.jfw.log.Wog;


public class SysInfo {

	static String	osName;
	public static String macAddr = null;
	static String userName = "";
	static String nicNm = null;

	public static String pcName = "";

	
	static {
		osName = System.getProperty("os.name");
		userName = System.getProperty("user.name");
	}
	
	
	static public boolean isWindows() {
		return osName.startsWith("Windows");
	}

	static public boolean isLinux() {
		return osName.startsWith("Linux");
	}

	
	public static String getOsName() {
		return osName;
	}
	
	
	static public String getMacAddr(Object ip) {
		if (macAddr == null) {
			if (ip instanceof InetAddress)
				findMacForAddr((InetAddress)ip);
			else if (ip instanceof String)
				findMacForIp((String)ip);
			else
				findMacAddr();
		}
		return macAddr;
	}
	

	private static String findMacForIp(String ipStr) {
		String mac = "";
		try {
			InetAddress ia = InetAddress.getByName(ipStr);
			return findMacForAddr(ia);
		} catch (Exception e) {
		}
		macAddr = mac;
		return mac;
	}

	public static String findMacForAddr(InetAddress ia) {
		String mac = "";
		try {
			NetworkInterface nic = NetworkInterface.getByInetAddress(ia);

			// read mac addr
			byte[] ha = nic.getHardwareAddress();
			for (int i=0; i<ha.length; i++) {
				mac += String.format("%02X", ha[i]);
			}
		} catch (Exception e) {
		}
		macAddr = mac;
		return mac;
	}

	

	public static String findMacAddr() {
		//String macAddr = null;
		try {
			String ip, host;
			Enumeration<NetworkInterface> en = NetworkInterface.getNetworkInterfaces();
			while(en.hasMoreElements()) {
				NetworkInterface ni = en.nextElement();
				// if (ni.isLoopback()) continue;

				Enumeration<InetAddress> inetAddresses = ni.getInetAddresses();
				while(inetAddresses.hasMoreElements()) {
					InetAddress ia = inetAddresses.nextElement();
					if (ia.getHostAddress() != null && ia.getHostAddress().indexOf(".") != -1) {
						ip = ia.getHostAddress(); //ip 체크
						host = ia.getHostName(); //hostname 체크
						//WizLog.n(ip + "  " + host);
						if ("127.0.0.1".equals(ip) || "localhost".equals(host))
							continue;

						NetworkInterface nic = NetworkInterface.getByInetAddress(ia);

						// read mac addr
						macAddr = "";
						byte[] mac = ni.getHardwareAddress();
						for (int i=0; i<mac.length; i++) {
							macAddr += String.format("%02X", mac[i]);
						}
						nicNm = nic.getDisplayName();
						if (!nicNm.startsWith("VMware"))
							return macAddr;
					}
				}
			}
		} catch (SocketException e) {
			Wog.e(e);
		}
		if (macAddr == null)
			macAddr = "";
		return macAddr;
	}

	public static String findPcName_() {
		
		try {
			InetAddress addr = InetAddress.getLocalHost();
			pcName = addr.getHostName();
		} catch (Exception e) {
		}
		return pcName;
	}


	// call client
	public static void reboot() {
		if (! isWindows()) {
			Wog.e("Reboot, ignored41");
			return;
		}
		
		// reboot
		Wog.e("Rebooting ...");
		try {
			String shutdownCmd = "shutdown /r /t 5";
			//String shutdownCmd = "shutdown /g /t 5";
			// Process child = 
			Runtime.getRuntime().exec(shutdownCmd);
		} catch (Exception e) {
			Wog.e(e.toString());
		}
	}
	

}

