
package wizframe.jfw.cpu;

import java.io.FileInputStream;
import java.io.FileOutputStream;

import util.NumUt;
import util.OsBean;
import util.Out;
import wizframe.jfw.core.SysInfo;
import wizframe.jfw.log.Wog;

/**
 * Timer interval checker
 */
public class CpuBalancer {

	//static final int MAX_INT=  999999999;
	//static final int MAX_INT=     88888888;
	//static final int MAX_INT=        7777777;
	static final int MAX_INT=        9999999;
	
	//static Leveler lver = new Leveler(1, MAX_INT, 1000);
	static Leveler lver = new Leveler(1, MAX_INT, 100);

	boolean gogo = false;


	public void stopTh() {
		gogo = false;
	}

	public void startTh(final int mili, Out out) {
		gogo = false;
		try { Thread.sleep(mili); } catch (Exception e) {}

		Thread th = new Thread() {
			@Override
			public void run() {
				setName("Magic Balancer");
				checkTh(mili, out);
			}
		};

		gogo = true;
		th.start();
	}
	
	void checkTh(int mili, Out out) {
		out.n("start cpuTh");
	
		//Interval intv = new Interval(5*60*1000);
		Interval intv = new Interval(5*1000);
		
		// check max cpu
		int minCnt = 5;
		while (gogo) {
			try { Thread.sleep(mili); } catch (Exception e) {}
			
			double maxCpu = getMaxCpuPer();
			double curCpu = OsBean.cpuPer();

			if (minCnt>0) {
				minCnt --;
				continue;
			}

			double diff = maxCpu - curCpu;
			// TODO adjust
			double add1 = 0.3*diff ; 		// 10~20%
			
			double add2	= 10.0*diff *lver.curVal();
			//add2	*= 0.00060;	//  %
			add2	*= 0.00100;	// 30,50 %
			//add2	*= 0.00120;	// 40 50 -10 % good
			//add2	*= 0.00130;	// 50 %
			//add2	*= 0.00150;	// 40 %
			
			lver.add(add1 + add2);
			
			if (intv.isOver()) {
				// 다른 process 와 비교 반영하기
				int valMy  = lver.curVal();
				int valYou = readInterval();	// read from file
				if (valYou > 0) {
					int valDif = Math.abs(valYou - valMy);
					int val10P = (int)(valMy*.1);
					// adjust
					if (valDif > val10P) {				
						// save
						if (val10P<2) val10P = 2;
						lver.add(valMy<valYou ? val10P : -val10P);
						saveInterval(lver.curVal());
					}
				}

				out.n(String.format("max:%3.1f cur:%3.1f diff:%4.1f add1:%4.1f add2:%4.1f Int:%4d",
					maxCpu, curCpu, diff, add1, add2, lver.curVal()));
			}
		}
		out.n("stop cpuTh");
	}
	
	public double getMaxCpuPer() {
		return 40.0;		
	}

	
	Counter count = null;
	
	public CpuBalancer() {
		count = new Counter();
	}

	public void sleep() {
		if (count.isOver(lver.curVal())) {
			if (!lver.isMax()) {
				//try { Thread.sleep(0, 1); } catch (Exception e) { }
				try { Thread.sleep(0, 10); } catch (Exception e) { }	// 241001
			}
		}
	}

	final static String CpuIntvFile = SysInfo.isLinux() ? "/home/deep/cpu.cfg" : "cpu.cfg";
	
	// read interval from file
	private int readInterval() {
		int val = -1;
		FileInputStream fin = null;
		try {
			fin = new FileInputStream(CpuIntvFile);
			int len = fin.available();
			byte []bb = new byte[Math.min(len, 100)];
			fin.read(bb);
			fin.close();
			String tx = new String(bb).trim();
			tx = tx.split("[\r\n \t]+")[0];
			val = NumUt.toInt(tx, -1);			
		} catch (Exception e) {
			try { if(fin != null) fin.close(); } catch (Exception e2) { }
		}
		///Wog.n("Read cpu.cfg: " + val);
		return val;
	}

	// save interval to file
	private void saveInterval(int intv) {
		FileOutputStream fout = null;
		try {
			fout = new FileOutputStream(CpuIntvFile);
			String val = ""+intv+"\n";
			///Wog.n("Save cpu.cfg: " + val);
			fout.write(val.getBytes());
		} catch (Exception e) {
			Wog.e(e.toString());
		} finally {
			try { if(fout != null) fout.close(); } catch (Exception e2) { }
		}
	}


}
