
package wizframe.jfw.log;

import java.io.PrintWriter;
import java.io.StringWriter;
import java.lang.reflect.Field;
import java.text.SimpleDateFormat;
import java.util.Collection;
import java.util.Map;

import wizframe.jfw.core.Calen;
import wizframe.jfw.core.Caller;

/**
 * Useful logging utility
 */

public class Wog {

	//static final String logPkg = "wizframe";
	
	public static int LogError	= 0;
	public static int LogWarn	= 1;
	public static int LogInfo	= 2;

	static private void logn(Object o) {
		String cal = new Caller().callerMethod(1);
		System.out.println(Calen.curYMDHMS19() + " " + cal + " "+ o.toString()); 
	}

	static int getLogLevel() {
		//return OptionPop.logLevel;
		return 4;
	}

	static public void e(Object o) {
		if (getLogLevel() >= LogError)
			logn(o);
	}

	static public void w(Object o) {
		if (getLogLevel() >= LogWarn)
			logn(o);
	}

	static public void i(Object o) {
		if (getLogLevel() >= LogInfo)
			logn(o);
	}
	
	static boolean isBaseObject(Object o) {
		if (o instanceof String || o instanceof Integer || o instanceof Long
			|| o instanceof Double || o instanceof Float || o instanceof Character || o instanceof Boolean
			|| o instanceof SimpleDateFormat
			)
			return true;
		return false;
	}

	// get string for all child object
	public static String toText(Object o) {
		if (o == null)
			return "nul";

		else if (isBaseObject(o)) {
			return toText(o.toString(), 0, 0);
		}
		return "\n" + toText(o, 0, 0);
	}

	final static String sps = "                                                   ";

	// get string for all child object
	public static String toText(Object o, int lv, int depth) {
		// System.out.println(depth);
		if (depth>10)
			return o.toString();

		StringBuilder sb = new StringBuilder();

		if (isBaseObject(o)) {
			sb.append(o.toString() );
		}
		// Map
		else if (o instanceof Map) {
			Map<?,?> map = (Map<?,?>) o;
			Object []key = map.keySet().toArray();

			for (int i=0; i<key.length; i++) {
				Object val = map.get(key[i]);
				if (i==0) {
					sb.append("Map of " + val.getClass().toString() + "\n");
				}
				sb.append(key[i] + " : " + toText(val, 1, depth+1) + "\n");
			}
		}
		// ModelMap
		/*else if (o instanceof ModelMap) {
			ModelMap map = (ModelMap) o;
			Object []key = map.keySet().toArray();

			for (int i=0; i<key.length; i++) {
				Object val = map.get(key[i]);
				if (i==0)
					sb.append("ModelMap of " + val.getClass().toString() + "\n");
				sb.append(key[i] + " : " + toText(val, 1) + "\n");
			}
		}*/
		// Object[]
		else if (o instanceof Object[]) {
			Object[] arr = (Object[]) o;
			if (arr.length > 0) {
				if (arr[0] instanceof Object[]) {
					sb.append("[] of " + arr[0].getClass().toString() + "\n");
					for (int i=0; i<arr.length; i++) {
						sb.append("" + toText(arr[i], 1, depth+1) + "\n");
					}
				} else {
					//sb.append("[] of " + arr[0].getClass().toString() + "\n");
					for (int i=0; i<arr.length; i++) {
						if (i>0) sb.append(", ");
						//sb.append("" + toText(a[i], 1, depth+1) + "\n");
						sb.append(arr[i]);
					}
				}
			}
		}
		// Collection
		else if (o instanceof Collection<?>) {
			Object[] list = ((Collection<?>) o).toArray();
			if (list.length > 0) {
				sb.append("Collection of " + list[0].getClass().toString() + "\n");
				for (int i=0; i<list.length; i++) {
					sb.append("" + toText(list[i], 1, depth+1) + "\n");
				}
			}
		}

		else if (o instanceof Exception) {
			sb.append(getCallList0((Exception) o));
			sb.append(getCallList((Exception) o));
		}
		//else if (o instanceof ResultCode){
		//	sb.append("ResultCode: " + o);
		//}
		else {
			String clz = o.getClass().toString();
			sb.append(clz + " [\n");

			sb.append(getTextViaReflect(o, 1, depth+1));
			sb.append("]");
		}

		return addSpace(sb.toString(), lv);
	}

	private static Object getCallList0(Exception o) {
		StringWriter sw = new StringWriter();
		PrintWriter pr = new PrintWriter(sw);
		Exception e = (Exception) o;
		e.printStackTrace(pr);
		return sw.getBuffer();
	}

	private static Object getCallList(Exception o) {
		StringBuilder sb = new StringBuilder();
		StackTraceElement el[] = o.getStackTrace();

		sb
		.append(o.getClass().getName()).append(": ")
		.append(o.getMessage())
		.append("\n");
		for (int i=0; i<Math.min(el.length, 10); i++) {
			StackTraceElement st = el[i];
			sb.append("  at " + st.toString()).append("\n");
		}
		return sb.toString();
	}

	private static String addSpace(String rec, int lv) {
		if (rec==null || rec.isEmpty())
			return "";

		boolean isNl = rec.endsWith("\n");
		String []ar = rec.split("\n");
		StringBuilder sb = new StringBuilder();
		for (String txt : ar) {
			if (txt.isEmpty())
				continue;
			sb.append(sps.substring(0, lv*2));
			sb.append(txt).append("\n");
		}
		if (isNl)
			return sb.toString();
		return sb.substring(0, sb.length()-1);
	}

	/** get values via Getter method */
	static String getTextViaReflect(Object o, int lv, int depth) {
		boolean skipNull = false;
		//if (o instanceof CommonRequest  || o instanceof CommonResponse
		//		|| o instanceof CommonHeader || o instanceof ApprovalData || o instanceof EAIData
		//		|| o instanceof FepData || o instanceof MessageResponse)
		//	skipNull = true;

		StringBuilder sb = new StringBuilder();
		try {
			Class<?> cls = o.getClass();

			Field [] fld;
			fld = cls.getDeclaredFields();
			getTextViaReflectSub(o, fld, skipNull, sb, depth+1);

			fld = cls.getSuperclass().getDeclaredFields();
			getTextViaReflectSub(o, fld, skipNull, sb, depth+1);

		} catch (Exception e) {
			//WizLog.log (e);
		}
		//return sb.toString();
		return addSpace(sb.toString(), lv);
	}

	/** get values of fields */
	private static void getTextViaReflectSub(Object o, Field[] fld, boolean skipNull, StringBuilder sb, int depth) {

		for(int i=0; i<fld.length; i++) {
			try {
				String var = "";
				String val = "";
				String name = fld[i].getName();
				/*if (name.equals("OpmkNdy3Dt")) {
					Wog.println("z");
				}*/

				var += name + ": ";
				fld[i].setAccessible(true);

				Object o2 = fld[i].get(o);
				if (o2 instanceof Object[])
					val = toText(o2, 0, depth+1).trim();
				else if (isBaseObject(o2))
					val = o2.toString();
				else if (o2 == null)
						val = "";
				else
					val = toText(o2, 0, depth+1);

				if (skipNull && (val==null || val.trim().isEmpty()))
					continue;
				else
					sb.append(var + val).append("\n");
			} catch (Exception e) {
				//log(3,e);
			}
		}
	}

	static public String srcPosition() {
		return new Caller().callerMethod(1);
	}

	//static void log_(Object o) { System.out.println(o); }

	public static void println(Object o) { System.out.println(o); }
	public static void print(Object o) { System.out.print(o); }
	public static void quiet(Object o) { ; }

	public static void n(Object o) {
		System.out.println(Calen.curYMDHMS19() + " " + new Caller().callerMethod(1)+ ": " + toText(o));
	}
	
	public static void a(Object o) {
		System.out.print(Calen.curYMDHMS19() + " " + new Caller().callerMethod(1)+ ": " + toText(o));
	}
	
	public static void z(Object o) { }

//	private static void a1() {
//		a2();
//	}
//	private static void a2() {
//		a3();
//	}
//	private static void a3() {
//		a4();
//	}
//	private static void a4() {
//		try {
//			int p = Integer.parseInt("a");
//			//Wog.n(new Exception("aaaa"));
//		} catch (Exception e) {
//			Wog.n(e);
//		}
//	}


//	public static void main(String[] args) {
//		String [][] ar = {
//				{"a", "b", "c" },
//				{"a", "b", "c" },
//		};
//		Wog.n(ar);
//	}
}


/*
// get Strings via Getter method
static String getTextViaGetter(Object o, int lv) {
	boolean skipNull = false;
	if (o instanceof CommonRequest  || o instanceof CommonResponse
			|| o instanceof CommonHeader || o instanceof ApprovalData || o instanceof EAIData
			|| o instanceof FepData || o instanceof MessageResponse)
		skipNull = true;

	Class<?> cls = o.getClass();

	Method me[] = cls.getDeclaredMethods();
	//Method me[] = cls.getMethods();

	String fn, val;
	StringBuffer sb = new StringBuffer();

	for(int i=0; i<me.length; i++) {
		try {
			String var = "";
			fn = me[i].getName();
			if (!fn.startsWith("get")) continue;

			var = fn.substring(3,4).toLowerCase() + fn.substring(4) + ": ";

			Object o2 = me[i].invoke(o);
			if (o2 instanceof Object[])
				val = toText(o2, lv).trim();
			else if (isBaseObject(o2))
				val = o2.toString();
			else if (o2 == null)
				val = "";
			else
				val = toText(o2, lv);

			if (skipNull && (val==null || val.trim().isEmpty()))
				continue;
			else
				sb.append(var + val).append("\n");
		} catch (Exception e) {
			//WizLog.log (e);
			//loge(e);
		}
	}
	return sb.toString();
}
*/

