
package quiz;

import wizframe.jfw.cpu.CpuBalancer;
import wizframe.jfw.secu.util.SecRand;

public class Quiz {

	protected final static boolean T = true;
	protected final static boolean F = false;

	protected byte [][]z;
	protected CpuBalancer cpuBal;

	protected String prefix = "";

	public void setPrefix(String key) {
		prefix = key;		
	}
	

	protected int z(int rc) {
		return z[rc/10][rc % 10];
	}
	
	protected byte[] zarr(int... p) {
		byte[] ar = new byte[p.length];
		for (int i=0; i<p.length; i++) {
			int r = p[i]/10;
			int c = p[i]%10;
			ar[i] = z[r][c];
		}
		return ar;
	}

	protected boolean zhas(int val, int... ar) {
		for (int p : ar) {
			if (val == z(p)) return T;
		}
		return F;
	}

	
	public String ansLine() {
		String txt = "";
		for (int y=0; y<z.length; y++) {
			//txt += toStr(z[y]);
			txt += toTxt(z[y]);
		}
		return txt;
	}
	
	public String ansBox() {
		String txt = ".\n";
		for (int y=0; y<z.length; y++) {
			txt += "\n"+ toTxt(z[y]);
		}
		return txt;
	}
	
	public void setCpuBalancer(CpuBalancer cpuBal) {
		this.cpuBal = cpuBal;
	}

	protected void sleep() {
		if (cpuBal != null) cpuBal.sleep();
	}
	
	
	
	
	// 0~9 A-Z a-z { |
	//     10  36  62
	public static char toCh(byte b) {
		b--;
		char ch = 0;
		if 		(b<10) ch = (char) ('0'+ b);
		else if (b<36) ch = (char) ('A'+(b-10));
		else 		   ch = (char) ('a'+(b-36));
		return ch;
	}

	public static byte toInt(char ch) {
		byte v = 0;
		if 		(ch<'A') v = (byte)(1+ch-'0');
		else if (ch<'a') v = (byte)(1+ch-'A'+10);
		else 			 v = (byte)(1+ch-'a'+36);
		return v;
	}

	public static String toStr(byte []ar) {
		String txt = "";
		for (byte v : ar) {
			txt += toCh(v);
		}
		return txt;
	}

	public static String toTxt(byte[] ar) {
		String txt = "";
		for (int x=0; x<ar.length; x++) {
			txt += String.format("%d", ar[x]);
			if (x<ar.length-1)
				txt += ",";
		}
		return txt;
	}


	public static byte [] toArr(String txt) {
		byte [] ar = new byte[txt.length()];
		for (int i=0; i<txt.length(); i++) {
			ar[i] = toInt(txt.charAt(i));
		}
		return ar;
	}

	// call by viewer
	public static String[] toStrArr(String txt) {
		return txt.indexOf("0")>=0 ? toStrArrNew(txt) : toStrArrOld(txt);
	}
	
	/**
	 * num, alpha version
	 * @param txt
	 * @return
	 */
	public static String[] toStrArrNew(String txt) {
		String[] ar = txt.split("");
		try {
			for (int i=0; i<ar.length; i++) {
				char c = ar[i].charAt(0);
				int no = toInt(c);
				ar[i] = ""+no;
			}
		} catch (Exception e) {
			; //Wog.e(e);
		}
		return ar;
	}
	
	/**
	 * alpha version
	 * @param txt
	 * @return
	 */
	public static String[] toStrArrOld(String txt) {
		String[] ar = txt.split("");
		try {
			for (int i=0; i<ar.length; i++) {
				char c = ar[i].charAt(0);
				int no = c<='Z' ? (c-'A'+1) : (c-'a'+26+1);
				ar[i] = ""+no;
			}
		} catch (Exception e) {
			; //Wog.e(e);
		}
		return ar;
	}

	/**
	 * convert alpha to num+alpha
	 * @param txt
	 * @return
	 */
	public static String toNewStr1(String txt) {
		String[] ar = txt.split("");
		String out = "";
		try {
			for (int i=0; i<ar.length; i++) {
				char c = ar[i].charAt(0);
				int no = c<='Z' ? (c-'A'+1) : (c-'a'+26+1);
				out += toCh((byte)no);
			}
		} catch (Exception e) {
			; //Wog.e(e);
		}
		return out;
	}
	
	/**
	 * convert lower to num+alpha
	 * @param txt
	 * @return
	 */
	public static String toNewStr2(String txt) {
		String[] ar = txt.split("");
		String out = "";
		try {
			for (int i=0; i<ar.length; i++) {
				char c = ar[i].charAt(0);
				int no = c - 'a' +1;
				out += toCh((byte)no);
			}
		} catch (Exception e) {
			; //Wog.e(e);
		}
		return out;
	}
	
	public static byte[] addArr(byte[] ar, byte[] br) {
		byte[] cr = new byte[ar.length + br.length];
		System.arraycopy(ar, 0, cr, 0, ar.length);
		System.arraycopy(br, 0, cr, ar.length, br.length);
		return cr;
	}

	public static byte[][] getRand(byte[][] bk, double per) {
		int tot = bk.length;
		int len = (int) (tot * per / 100);
		
		// make random index
		int []inx = SecRand.nextIntArr(tot, len);
		
		// get random array
		byte[][] br = new byte[len][];
		for (int i=0; i<len; i++) {
			br[i] = bk[inx[i]];
		}
		
		return br;
	}

	public static byte[][] getSub(byte[][] bk, int srt, int len) {
		byte[][] br = new byte[len][];
		for (int i=0; i<len; i++) {
			br[i] = bk[srt+i];
		}
		
		return br;
	}
	
}
