
package quiz4;

import util.Out;
import wizframe.jfw.core.NanoTimer;
import wizframe.jfw.log.Wog;

public class Magic40 extends Magic {

	public Magic40() {
		super(4);
	}


	/**
	 * Solve 4-th magic
	 */
	public void solve() {
		Wog.n("");

		ans = new Out("ans40.txt");

		int nSol = 0;
		NanoTimer tm = new NanoTimer();
		tm.start();
		
		solveUq12();
		Wog.n("solveUq() " + tm.getDiff() + " ans: " + nAnswer);
		ans.a("-------");
		
		nSol = nAnswer;
		solveDig11();
		Wog.n("solveDig00() " + tm.getDiff() + " ans: " + (nAnswer -nSol));
		ans.a("-------");

		nSol = nAnswer;
		solveDig22();
		Wog.n("solveDig11() " + tm.getDiff() + " ans: " + (nAnswer -nSol));
		
		// 00:00.246 ans: 880
		// 00:00.168 ans: 880
		// 00:00.120 ans: 1760
		// 00:00.086 ans: 1760 map: 236
		// 00:00.155 ans: 880 map: 0
		
		pm.mapInfo();
	}


	/**
	 *  1 unique
	 */
	public void solveUq12() {
		// dir right aAaa
		for (byte[] ar : pm.getOnePm()) {
			zset(ar, 1,2,3,0);
			pm.lock(ar, 0);
			
			// dir down BBB
			for (byte[] br : getLike(0)) {
				zset(br, 10,20,30);
				pm.lock(br, 1);
				
				// dir down CCC
				for (byte[] cr : getLike(01)) {
					zset(cr, 11,21,31);
					pm.lock(cr, 1);
				
					// row right DD
					for (byte[] dr : getLike(10,11)) {
						zset(dr, 12,13);
						if (!checkDiaDes()) continue;

						pm.lock(dr, 2);

						// row right EE
						for (byte[] er : getLike(20,21)) {
							zset(er, 22,23);
							pm.lock(er, 2);
						
							// row right FF
							for (byte[] fr : getLike(30,31)) {
								zset(fr, 32,33);
				
								if (!checkCol(2)) continue;
								if (!checkDiaAsc()) continue;
					
								ans.a(ansLine());
								nAnswer ++;

							} // f
							pm.pop();
						} // e
						pm.pop();
					} // d
					pm.pop();
				} // c
				pm.pop();
			} // b
			pm.pop();
		} // a
	}


	/**
	 * 대각 대칭
	 */
	public void solveDig11() {
		solveDig(T);
	}
	
	public void solveDig22() {
		solveDig(F);
	}
	
	public void solveDig(boolean is11)  {
		// dir right AAaa
		for (byte[] ar : pm.getOnePm()) {
			if (is11) {
				zset(ar, 00,11,22,33);
			} else {
				zset(ar, 11,22,33,00);
			}
			pm.lock(ar, 0);
			
			// dir down .BBB
			for (byte[] br : getLike(0)) {
				zset(br, 10,20,30); 
				if (zhas(2, 10,20,30)) continue;
				
				pm.lock(br, 1);
				
				// dir down .CC.
				for (byte[] cr : getLike(30, 33)) {
					zset(cr, 31,32);
					if (zhas(2, 31,32)) continue;
					
					pm.lock(cr, 2);
					
					// row right .D.D
					for (byte[] dr : getLike(20,22)) {
						zset(dr, 21,23);
						if (zhas(2, 21)) continue;

						pm.lock(dr, 2);
						
						// row right EE
						for (byte[] er : getLike(10,11)) {
							zset(er, 12,13);
							
							pm.lock(er, 2);
							//if (pm.lockSize() != MAX-3)
							//	Wog.n("err lockPerm : " + pm.lockSize());
						
							// row right FF
							for (byte[] fr : getLike(0)) {
								zset(fr, 1,2,3);
					
								if (!checkDiaDes()) continue;						
								if (!checkCol(1)) continue;
								if (!checkCol(2)) continue;
					
								ans.a(ansLine());
								nAnswer ++;

							} // f
							pm.pop();
						} // e
						pm.pop();
					} // d
					pm.pop();
				} // c
				pm.pop();
			} // b
			pm.pop();
		} // a
	}


	private boolean checkDiaAsc() {
		return (SUM == z[0][0] +z[1][1] +z[2][2] +z[3][3]);
	}

	private boolean checkDiaDes() {
		return (SUM == z[0][3] +z[1][2] +z[2][1] +z[3][0]);
	}
	
	private boolean checkCol(int i) {
		return (SUM == z[0][i] +z[1][i] +z[2][i] +z[3][i]);
	}

//	private boolean checkRow(int i) {
//		return (SUM == z[i][0] +z[i][1] +z[i][2] +z[i][3]);
//	}

	public static void main(String[] args) {
		new Magic40().solve();
	}

	
}
