
package quiz4;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Comparator;
import java.util.List;
import java.util.Stack;
import java.util.concurrent.ConcurrentHashMap;

import wizframe.jfw.core.Timer;
import wizframe.jfw.log.Wog;

public class Permu {

	static private int CNT;
	static private int MAX;
	static private int SUM;
	
	static private byte [][] pm = null;
	static byte[][] listOnePm = null;
	
	static private ConcurrentHashMap<String, int[]> inxMap = new ConcurrentHashMap<String, int[]>();

	private boolean[] freeNum;
	private Stack<boolean[]> lockStack = new Stack<boolean[]>();

	public void mapInfo() {
		Wog.n("map: " + inxMap.size());
	}

	public Permu(int cnt) {
		CNT =cnt;
		MAX =cnt*cnt;
		freeNum = new boolean[MAX+1];

		// calc sum
		int sum = 0;
		for (int i=0; i<CNT; i++) {
			int v = 1 + (i*CNT) + i;
			sum += v;
		}
		SUM = sum;
		
		for (int i=1; i<=MAX; i++)
			freeNum[i] = true;
		initPerm();
	}
	
	synchronized void initPerm() {
		if (pm == null)
			pm = makePerm();
		getOnePm();
	}

	int lockSize() {
		int cnt = MAX;
		for (int i=1; i<=MAX; i++)
			if (freeNum[i]) cnt--;
		return cnt;
	}
	
	
	void lock(byte[] ar, int p) {
		lockStack.push(freeNum.clone());
		
		for (int i=p; i<ar.length; i++) {
			freeNum[ar[i]] = false;
		}
	}
	
	void pop() {
		freeNum = lockStack.pop();
	}
	
//	void free(int [] sub) {
//		for (int i=0; i<sub.length; i++) {
//			freeNum[sub[i]] = true;
//		}
//	}


	/**
	 * 이미 사용안된 수들인가
	 * @param ar
	 * @param mask
	 * @return
	 */
	private boolean isFreeNum(byte[] ar, int nMask) {
		// TODO 여기를 줄이자
		for (int i=nMask; i<ar.length; i++) {
			if (!freeNum[ar[i]])
				return false;
		}
		return true;
	}


	static Comparator<byte[]> cmpArr = new Comparator<byte[]>() {
	    public int compare(byte[] arr, byte[] mask) {
	    	int nMask = mask.length;
	    	
	    	for (int i=0; i<nMask; i++) {
	    		int rc = arr[i] - mask[i];
	    		if (rc!=0)
	    			return rc;
	    	}
	    	return 0;
	    }
	};
	
	int searchPinx(byte []mask) {
		int rc = Arrays.binarySearch(pm, mask, cmpArr);
		if (rc>=0)
			throw new RuntimeException("search err");
		return -(rc+1);
	}

	int[] getSrtEndInx0(byte []mask) {
		int nMask = mask.length;
		byte[]key = new byte[nMask+1];
		System.arraycopy(mask, 0, key, 0, nMask);

		key[nMask] = 0;
		int p1 = searchPinx(key);
		key[nMask] = 99;
		int p2 = searchPinx(key);
		
		int[] ar = new int[] {p1, p2};
		return ar;
	}
	
	int[] getSrtEndInx(byte []mask) {
		if (CNT<=4)
			return getSrtEndInx0(mask);

		// check cache
		String ke = "";
		for (int i : mask) {
			ke += i+"_";
		}

		int[] ar = inxMap.get(ke);
		if (ar == null) {
			ar = getSrtEndInx0(mask);
			inxMap.put(ke, ar);
		}
		
		return ar;
	}
	
	/**
	 * 필요한(비슷한) 순열 찾기
	 * @param mask
	 * @return
	 */
	List<byte[]> getLike(byte... mask) {
		int nMask = mask.length;
		List<byte[]> list = new ArrayList<byte[]>();
		
		int []p2 = getSrtEndInx(mask);
		for (int k=p2[0]; k<p2[1]; k++) {
			byte[] ar = pm[k];
			if (isFreeNum(ar, nMask))
				list.add(ar);
		}
	
		return list;
	}


	/**
	 * 1 로 시작하는 perm 찾기
	 * @param a
	 * @param b
	 * @param c
	 * @return
	 */
	byte[][] getOnePm() {
		if (listOnePm == null) {
			List<byte[]> list = new ArrayList<byte[]>();
		
			for (byte[] ar : pm) {
				if (ar[0] == 1)
					list.add(ar);
				else
					break;
			}
			listOnePm = list.toArray(new byte[0][]);
		}
		return listOnePm;
	}

	/**
	 * 전체 순열 만들기
	 * @return
	 */
	static private byte [][] makePerm() {
		Timer tm = new Timer();
		List<byte[]> ar;
		if (CNT == 4)
			ar = makePerm4();
		else
			ar = makePerm5();
		
		byte[][] keys = ar.toArray(new byte[0][]);
		tm.stop();
		Wog.n(tm.getDiff() + " nPerm: " + keys.length);

		return keys;
	}
	
	static private List<byte[]> makePerm4() {
		List<byte[]> list = new ArrayList<byte[]>();

		for (byte a=1; a<=MAX; a++) {
			//Wog.n("a: " + a);
			for (byte b=1; b<=MAX; b++) {
				if (b==a) continue;
				for (byte c=1; c<=MAX; c++) {
					if (c==a ||c==b) continue;
					for (byte d=1; d<=MAX; d++) {
						if (d==a ||d==b ||d==c) continue;
						if (SUM != a+b+c+d) continue;

						list.add(new byte[] {a,b,c,d});		
					}
				}
			}
		}
		return list;
	}


	static List<byte[]> makePerm5() {
		List<byte[]> list = new ArrayList<byte[]>();

		for (byte a=1; a<=MAX; a++) {
			for (byte b=1; b<=MAX; b++) {
				if (b==a) continue;
				for (byte c=1; c<=MAX; c++) {
					if (c==a ||c==b) continue;
					for (byte d=1; d<=MAX; d++) {
						if (d==a ||d==b ||d==c) continue;
						for (byte e=1; e<=MAX; e++) {
							if (e==a ||e==b ||e==c ||e==d) continue;
							if (SUM != a+b+c+d+e) continue;

							list.add(new byte[] {a,b,c,d,e});
						}
					}
				}
			}
		}
		return list;
	}

}
