package util;

import java.lang.management.ManagementFactory;

import com.sun.management.OperatingSystemMXBean;

import wizframe.jfw.log.Wog;

public class OsBean {

	static OperatingSystemMXBean osBean = ManagementFactory.getPlatformMXBean(OperatingSystemMXBean.class);

	public static long memTotal() {
		return osBean.getTotalPhysicalMemorySize();
	}
	public static long memFree() {
		return osBean.getFreePhysicalMemorySize();
	}

	public static double getMemPer() {
		return 100.0 * (memTotal() - memFree())/memTotal();
	}

	public static long swapTotal() {
		return osBean.getTotalSwapSpaceSize();
	}
	public static long swapFree() {
		return osBean.getFreeSwapSpaceSize();
	}
	
	public static double cpuPer_() {
		return osBean.getSystemCpuLoad() * 100;
	}

	final static int nCpu = 8;
	//final static int nCpu = 3;
	static double aCpu[] = new double[nCpu];
	static int iCpu = 0;
	
	public static double cpuPer() {
		// average values
		double per = osBean.getSystemCpuLoad() * 100;
		aCpu[iCpu] = per;
		if (++iCpu >= nCpu)
			iCpu = 0;

		double sum = 0;
		int cnt = 0;
		for (int i=0; i<nCpu; i++) {
			if (aCpu[i]==0) continue;
			sum += aCpu[i];
			cnt ++;
		}
		return sum / Math.max(1, cnt);
	}

	public static int cpuCount() {
		return osBean.getAvailableProcessors();
	}

	public static String osName() {
		return /* osBean.getName() + " " + */osBean.getArch() + " " +osBean.getVersion();
	}

	public static void main(String[] args) {
		Wog.n(getMemPer());
	}
}
